/*
 * grader-comm - pugcp-proto.c
 *
 * Copyright (C) 2017  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <compiler.h>
#include <list.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <pu-proto.h>
#include <pu-proto-lib.h>
#include <pugcp-proto.h>
#include <pugcp-proto-lib.h>
#include <pu-lib.h>
#include <pu-buff.h>

static void pugcp_proto_hdr_init(struct pugcp_header *hdr,
		unsigned int proto, unsigned int node, unsigned int command)
{
	hdr->checksum = cpu_to_be32(0);
	hdr->proto = cpu_to_be32(proto);
	hdr->node = cpu_to_be32(node);
	hdr->command = cpu_to_be32(command);
}

struct pu_buff *pugcp_proto_alloc_skb(unsigned int count)
{
	struct pu_buff *n;

	n = pu_proto_alloc_skb(sizeof(struct pugcp_header) + count);
	if (!n)
		return NULL;
	pu_skb_reserve(n, sizeof(struct pugcp_header));
	return n;
}

int pugcp_proto_xmit_new(void *priv, struct pu_buff *skb,
		unsigned int proto, unsigned int node,
		unsigned int command, unsigned int id)
{
	struct pugcp_header *hdr;

	hdr = (void *)pu_skb_push(skb, sizeof(*hdr));
	pugcp_proto_hdr_init(hdr, proto, node, command);
	return pu_proto_xmit_new(priv, skb, PU_PROTO_GRADER, id);
}
