/*
 * Copyright (C) 2017  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifndef PUGCP_PROTO_H_INCLUDED
#define PUGCP_PROTO_H_INCLUDED

#include <compiler.h>
#include <asm_types.h>

struct pugcp_header {
	u32 checksum;
	u32 proto;
	u32 node;
	u32 command;
} __attribute__((packed));

#define PUGCP_PSCHED_ID_WRITE	0x80000000
#define PUGCP_PSCHED_ID_MASK	0x7fffffff
struct pugcp_psched {
	u32 id;
	u32 value;
} __attribute__((packed));

struct pugcp_cadd_event {
	u32 output;
	u32 position;
} __attribute__((packed));

struct pugcp_cpevent_info {
	u32 output;
	u32 position;
	u64 time_sec;
	u32 time_nsec;
} __attribute__((packed));

#endif
